---
title: Sprintwechsel KW30
tags: [sprint-report, roadmap-update]
---

Im Folgenden wollen wir euch ein kurzes Update bzgl. unseres Sprints geben.
Hierbei wollen wir auf die Stories eingehen, die wir bearbeitet haben, sowie den Stand der noch offenen Stories durchgeben.
Falls relevant soll auch ein entsprechendes Update der Roadmap kommuniziert werden.

Dieses Format soll nun bei jedem Sprintwechsel veröffentlicht werden.

## Stories

### Umgesetzt

#### Umsetzung des OAuth-Konzeptes

Ein neues OAuth Konzept soll umgesetzt werden, das detaillierte Berechtigungen für den API-Zugriff ermöglicht und eine
höhere Sicherheit für die Nutzung von Access Token gewährleistet.

Die Umsetzung des neuen OAuth-Konzeptes verzögerte die Bereitstellung der Testinfrastruktur. Aufgrund von
kurzfristigen Änderungen im Konzept mussten und müssen wir noch etwas umbauen. Der Großteil des Konzeptes ist bereits
abgeschlossen und die wenigen Nacharbeiten werden im aktuellen Sprint bearbeitet und dokumentiert.

#### Neues Metadatenschema entwickeln

Ein Metadatensatz beschreibt die Struktur einer Einreichung und deren Inhalte, wie beispielsweise Anlagen oder Fachdaten.
Das bisherige Metadatenschema für Einreichungen wurde aus `beta7` komplett überarbeitet:

- Es ist als JSON-Schema beschrieben und orientiert sich an der [JSON Schema Spezifikation 2020-12](https://json-schema.org/specification-links.html#2020-12).
- Die Nutzung und die Struktur des Metadatenschemas wurden in der Dokumentation erläutert.
- Es besteht primär aus den fünf Bereichen Authentifizierungsinformationen, Inhaltsstruktur,
  Bezahlinformationen, Verwaltungsleistung und Rückkanal.

:::caution Hinweis
Das Metadatenschema ist aktuell in der Version `1.0.0-rc.2` verfügbar und wird zukünftig unabhängig vom Zustelldienst
versioniert, um größtmögliche Flexibilität und Erweiterbarkeit zu erzielen.
:::

#### Info-Endpunkt liefert die falsche Version

Wir hatten im Zustelldienst den Fehler, dass über den Endpunkt `/info` die falsche Version ausgegeben wurde. Dieses Problem
wurde behoben und sollte nicht mehr auftreten.

#### Erstellung eines Konzepts zur Ableitung eines JSON Schemas aus einem FIM Stammdatenschema

Aktuell werden aus einem Stammdatenschema einer Antragsleistung, einer XML-Datei zur Generierung von Anträgen,
in FIM ein XML-Schema für die Datenübertragung abgeleitet. Dieses Schema wird umgangssprachlich XFall Schema bzw.
XFall Schema genannt.

Durch die Verbreitung von JSON wurde für Fachdaten auf FIM Basis eine JSON Schema basierte Variante entwickelt. Dieses soll
kurzfristig als Zusatzoption ermöglicht werden und langfristig als Ersatz für das bestehende XML Schema platziert werden.

Es wurde erprobt und dokumentiert, wie ein solches JSON-Schema allgemein und über eine eigene Software abzuleiten ist, sodass
dies zukünftig automatisiert durchgeführt werden kann.

### Im Sprint nicht abgeschlossene Stories

#### Event Log der Submission

Der bisherige Übermittlungsstatus wird durch einen Security Event Log ersetzt, der aus signierten Security Event Tokens
nach [RFC 8417](https://datatracker.ietf.org/doc/html/rfc8417) besteht und die einzelnen Übermittlungsschritte beweissicher
dokumentiert. Die jeweiligen Security Event Tokens sind durch die jeweils verantwortlichen Systeme (Zustelldienst bzw.
das empfangende System) zu erstellen und zu signieren. Dieser Security Event Log kann über die API von beiden Parteien
abgerufen werden und dient späteren Nachweisen über die korrekte Zustellung.

Die Implementierung des Security Event Logs ist größten teils abgeschlossen, muss jedoch noch final getestet und
dokumentiert werden.

#### Schlüsselverwaltung des Zustelldienstes

Aufbauend auf die vorherige Thematik des Event Logs benötigt ein Zustelldienst ein öffentliches "JSON Web Key (JWK)"-Set
nach [RFC 7517](https://tools.ietf.org/html/rfc7517), worin er seine öffentlichen Schlüssel zur Verfügung stellt, mit denen
die Signatur eines Security Event Tokens überprüft werden kann.

Hier fehlt noch die Dokumentation der Erreichbarkeit des JWK-Sets und wie dieses angewendet werden kann.

#### Implementierung des neuen Statusmodells

Ebenfalls im Kontext der Umsetzung des Event Logs ist die Implementierung des neuen Statusmodells anzusiedeln. Eine
Einreichung wird zukünftig einen Status innehaben, der über definierte Events in Form von Security Event Tokens verändert
werden kann.

Die Implementierung des neuen Statusmodells wurde im Rahmen der Umbauten durch den Event Log abgeschlossen und muss im
Rahmen dieser noch mit dokumentiert werden.

#### `schema` in `submissionSchemas` umbenennen

Als Follow-Up aus einem vorherigen Sprint wurde beschlossen, dass der technische Bezeichner der "Fachschemareferenz"
an verschiedensten Stellen von `schema` zu `submissionSchemas` geändert wird.

Die Umsetzung hiervon konnte noch nicht begonnen werden und wird daher in einem der nächsten Sprints angegangen.

## Roadmap Update

Unser Ziel eine Vorabversion der API und ein frei zugängliches Testsystem bereitzustellen verschiebt sich auf Anfang August.

---

Bei Fragen, Hinweisen oder Wünschen freuen wir uns gerne über Feedback. Dieses bitte über
unseren [Service Desk](https://jira.fjd.de/servicedesk/customer/portal/5) einkippen.
